import pgzrun

# This is a standard python module for
#  generating random numbers
import random


# Used for exiting the program
import sys


music.play('battle_music')


# This variable is provided by pygame zero
#   and controls changes to the window title
TITLE = 'Knight Fight'


# These variables are provided by pygame zero
#   and control the window dimensions
WIDTH = 640
HEIGHT = 288

# Create an actor object
#   for our "player" character
knight = Actor('my_knight')
ground = (HEIGHT - 80)
heart = Actor('heart')
# Change the x and y position of the explorer
#   Actor object

knight.idle_image = 'my_knight'
knight.attack_frames = ['attack_1', 'attack_2', 'attack_3', 'attack_4']
knight.attack_frame_index = 0
knight.current_frame = 0
knight.direction = 1
knight.render = True 
knight.pos = (100, ground)
knight.lives = 4
knight.invincible = False
knight.attacking = False
knight.run_frames_index = 0
knight.walk = {'left':[], 'right':[]}
knight.run_frames_index = 0
for number in range(0,10):
    knight.walk['left'].append(f'runl_{number}')
    knight.walk['right'].append(f'runr_{number}')
knight.walk_direction = None
current_state = 0
STATE = ['title', 'gameplay', 'gameover']
skeleton_list = []
lives = [Actor('heart', bottomright=(WIDTH-(33*3)-3, HEIGHT-3)),
          Actor('heart', bottomright=(WIDTH-(33*2)-3, HEIGHT-3)),
          Actor('heart', bottomright=(WIDTH-33-3, HEIGHT-3)),
          Actor('heart', bottomright=(WIDTH-3, HEIGHT-3))]
game = current_state
difficulty = 50

def show_title_screen():
    screen.draw.text("Knight Fight", (WIDTH // 4, 100), color='#CC0000', fontsize=90)
    screen.draw.text("Press Any Key to Start", (WIDTH // 3, HEIGHT - 100), color='#CC0000', fontsize=35)


def show_gameover():
    global skeleton
    global knight
    global difficulty
    global STATE
    global current_state
    
    
    screen.draw.text("Game Over", (WIDTH // 4, 100), color='#CC0000', fontsize=70)
    screen.draw.text("Press Any Key to Start", (WIDTH // 3, HEIGHT - 100), color='#CC0000' , fontsize=25)

    
    
    
    
    
    
#     clock.unschedule(spawn_skeletons)
#     screen.draw.text("Game Over", (WIDTH // 4, 100), color='#CC0000', fontsize=70)
#     screen.draw.text("Press Any Key to Start", (WIDTH // 3, HEIGHT - 100), color='#CC0000' , fontsize=25)
#     knight.lives = 0
#     sounds.death_cry.play()
#     sounds.you_loose.play()
#     
#     
#     for skeleton in skeleton_list:
#         skeleton.clear()
    
    
#     if key == keys.SPACE:
#         current_state = 0
def draw_background():
    screen.blit('background', (0, 0))

def update(dt):
    global current_state
    global knight
    global STATE
    global current_state
    global skeleton_list

    if STATE[current_state] == STATE[1]:
        
        animate_skeletons()
        check_state(dt)
        check_skeleton_collisions()
        clean_up()
        knight.draw()
        knight_moving(dt)
        if knight.lives == 0:
            current_state += 1
            clock.unschedule(spawn_skeletons)
            clock.unschedule(vulnerable)
            clock.unschedule(knight_run)
            skeleton_list.clear()
            sounds.death_cry.play()
            sounds.you_loose.play()


def draw():
    global lives
    global skeleton_list
    global knight
    global STATE
    global current_state
    global background
    
    draw_background()
    
    if STATE[current_state] == STATE[0]:
        show_title_screen()
    
    elif STATE[current_state] == STATE[1]:
        knight.draw()
        
        for skeleton in skeleton_list:
            skeleton.draw()
            
        for index in range(knight.lives):
            lives[index].draw()
        
        knight.invincible = False
        
    elif STATE[current_state] == STATE[2]:
        show_gameover()   
    

# def update(dt):
#     animate_skeletons()
#     check_state(dt)
#     check_skeleton_collisions()
#     clean_up()
#     animate_knight()
#     knight.draw()
#     knight_moving(dt)
#     if knight.lives == 0:
#         current_state += 1
    
    
              
def animate_skeletons():
    global skeleton
    # It counts up and then back down repeatedly
    for skeleton in skeleton_list:
        if not (0 <= skeleton.current_frame + skeleton.direction < len(skeleton.frames)):
            skeleton.direction *= -1    
        
        skeleton.current_frame += skeleton.direction
        skeleton.image = skeleton.frames[skeleton.current_frame]
        

def spawn_skeletons():
    global skeleton_list
    
    xpos = random.randint(640, WIDTH)
    skeleton = Actor('my_skeleton')
    skeleton.frames = ['walk_1', 'walk_2', 'walk_3', 'walk_4', 'walk_5', 'walk_6']
    skeleton.pos = (640, ground+25)
    skeleton.current_frame = 0
    skeleton.direction = 1
    # Set a custom variable to remember to render (draw) it
    skeleton.render = True
    # Add it to the list of skeletons
    skeleton_list.append(skeleton)
   
def animate_knight():
    global knight
    knights = []
    for knight in knights:
        if not (0 <= knight.current_frame + knight.direction < len(knight.frames)):
            knight.direction *= -1    
        
        knight.current_frame += knight.direction
        knight.image = knight.frames[knight.current_frame]


def knight_attack():
    global knight
    if knight.attack_frame_index == len(knight.attack_frames):
        clock.unschedule(knight_attack)
        knight.image = knight.idle_image
        knight.attack_frame_index = 0
        knight.attacking = False
    else:
        knight.attacking = True
        knight.image = knight.attack_frames[knight.attack_frame_index]
        knight.attack_frame_index += 1
    
    
def move_skeleton(dt):
    global skeleton
    if STATE[current_state] == STATE[1]: 
        skeleton.x -= knight.x

def knight_moving(dt): #knight physically moving from side to side
    global knight
    if keyboard.right:
        knight.x += dt * 130  #determine the speed at which the knight slides
    if keyboard.left:
        knight.x -= dt *130
   
def knight_run():  #knight movement but getting the animation frames
    global knight
    
    if knight.walk_direction:                        
        knight.run_frames_index = (knight.run_frames_index + 1) % len(knight.walk[knight.walk_direction])
        knight.image = knight.walk[knight.walk_direction][knight.run_frames_index]
    
        
def on_key_down(key):
    global current_state
    global STATE
    
    if key == keys.ESCAPE:
        sys.exit()       
    if key and STATE[current_state] == STATE[0]:
        current_state += 1
        if current_state == 1:
            clock.schedule_interval(spawn_skeletons, 3)
            clock.schedule_interval(animate_skeletons, 0.2)
    if key == keys.SPACE and STATE[current_state] == STATE[1]:
        clock.schedule_interval(knight_attack, 0.2)
        sounds.sword_slice.play()
        
    if key == keys.RIGHT:
        if not knight.walk_direction:
            knight.walk_direction = 'right'
            clock.schedule_interval(knight_run, 0.2)

    if key == keys.LEFT:
        if not knight.walk_direction:
            knight.walk_direction = 'left'
            clock.schedule_interval(knight_run, 0.2)
    
    if key and STATE[current_state] == STATE[2]:
        current_state = 1
        clock.schedule_interval(spawn_skeletons, 5)
        knight.attack_frame_index = 0
        knight.current_frame = 0
        knight.direction = 1
        knight.render = True
        knight.pos = (100, ground)
        knight.lives = 4
        knight.invincible = False
        knight.attacking = False
        knight.run_frames_index = 0
        knight.walk_direction = None


def on_key_up(key):
    """
    This function gets called automatically when a key is released, but
    only the first time the key goes down.
    """
    global knight
    if key == keys.RIGHT:
        if knight.walk_direction:
            clock.unschedule(knight_run)
            knight.image = knight.idle_image
            knight.run_frames_index = 0  
            knight.walk_direction = None
    if key == keys.LEFT:
        if knight.walk_direction:
            clock.unschedule(knight_run)
            knight.image = knight.idle_image
            knight.run_frames_index = 0
            knight.walk_direction = None

  
def check_state(dt):
    global current_state
    global skeleton_list
    global skeleton
    for skeleton in skeleton_list:
        if skeleton.x < knight.x:
            skeleton.x += dt * 20
        else : skeleton.x -= dt * 20
# delta time time period 
def check_skeleton_collisions():
    global skeleton
    global skeleton_list
    global knight
    for skeleton in skeleton_list:
        if skeleton.colliderect(knight):
            skeleton.render = False
            knight.render = False
    
    for skeleton in skeleton_list:
        if knight.colliderect(skeleton):
            
            if knight.attacking:
                skeleton.render = False
                #sounds.explode.play()
            
            if not knight.invincible and not knight.attacking:
                knight.lives -= 1
                sounds.lost_a_heart.play()
    
            knight.invincible = True
            clock.schedule_unique(vulnerable, 5)
    

def vulnerable():
    global knight
    knight.invincible = False
                #sounds.explode.play()
    
def clean_up():
    global skeleton
    global skeleton_list
    global knight
    skelly_list = []
    for skeleton in skeleton_list:
        if not skeleton.x < 0 and skeleton.render:
            skelly_list.append(skeleton)
        
        skeleton_list = skelly_list
            

pgzrun.go()